// --- Critere.cpp

#include <stdlib.h>
#include <stdio.h>


#include "constante.h"
#include "critere.h"
#include "structure.h"

// acces variables globales
extern int end;
extern int nb_ressources;
extern int mcap;
extern int Ressources[MAX_RES][12];
extern ptaffect List_affect[MAX_RES*MAX_VEH];
extern ptmaint List_maint[MAX_RES*MAX_VEH];
extern ptrent List_rent[MAX_RES];


// procedure calcul du cout d'utilisation
int cout_utilisation(int type, int veh)
{
ptaffect pa;
int cout;

cout = 0;
if (List_affect[(type-1)*MAX_VEH + veh] != NULL)
	{
	pa = List_affect[(type-1)*MAX_VEH + veh];
	while (pa != NULL)
		{
		cout += (pa->et - pa->st) * Ressources[type][8] + Ressources[type][7];
		pa = pa->next;
		}
	}
return (cout);	
}


// procedure calcul du cout d'achat
int cout_achat(int type, int veh)
{
ptaffect pa;
int cout;

cout = 0;
if (List_affect[(type-1)*MAX_VEH + veh] != NULL)
	{
	pa = List_affect[(type-1)*MAX_VEH + veh];
	cout += Ressources[type][9] + (end - pa->st) * Ressources[type][10] ;
	while (pa != NULL)
		{
		cout +=  (pa->et - pa->st ) * Ressources[type][8]  + Ressources[type][7];
		pa = pa->next;
		}
	}
return (cout);	
}


// procedure calcul du cout de location
int cout_location(int type, int veh)
{
ptaffect pa;
int cout;

cout = 0;
if (List_affect[(type-1)*MAX_VEH + veh] != NULL)
	{
	pa = List_affect[(type-1)*MAX_VEH + veh];
	while (pa != NULL)
		{
		cout +=  (pa->et - pa->st) * Ressources[type][6];
		pa = pa->next;
		}
	}
return (cout);	

}


// procedure calcul du cout total
int cout_total()
{
ptrent pr;
ptmaint pm;
ptaffect pa;

int r, v, nb_vehic;
int cumul_cout;

cumul_cout = 0;

// Cout maintenance
for (r = 1; r <= nb_ressources; r ++)
	{
	nb_vehic = Ressources[r][2] + Ressources[r][12];
	for (v = 1; v <= nb_vehic; v++)
	   if (List_maint[(r-1)*MAX_VEH + v] != NULL)
		{
		pm = List_maint[(r-1)*MAX_VEH + v];
		while (pm != NULL)
			{
			cumul_cout += Ressources[r][11] ;
			pm = pm->next;
			}	
		}
	}
	
	
// Cout des locations
for (r = 1; r<=nb_ressources; r ++)
	if (List_rent[r] != NULL)
		{
		pr = List_rent[r];
		while (pr != NULL)
			{
			cumul_cout +=  (pr->order->et - pr->order->st ) * pr->r_number * Ressources[r][6];
			pr = pr->next;
			}
		}
	

// Cout utilisation
for (r = 1; r<=nb_ressources; r ++)
  for (v=1; v<=Ressources[r][2]; v++)
	if (List_affect[(r-1) * MAX_VEH + v] != NULL)
		{
		pa = List_affect[(r-1) * MAX_VEH + v];
		while (pa != NULL)
			{
			cumul_cout +=  (pa->et - pa->st) * Ressources[r][8] + Ressources[r][7]  ;
			pa = pa->next;
			}
		}
	

// Cout achat
for (r = 1; r<=nb_ressources; r ++)
	for (v=Ressources[r][2]+1; v<=Ressources[r][2]+Ressources[r][12]; v++)
		{
		if (List_affect[(r-1) * MAX_VEH + v] != NULL)
			{
			pa = List_affect[(r-1) * MAX_VEH + v];
			cumul_cout += Ressources[r][9] + (end-pa->st) * Ressources[r][10] ;
			while (pa != NULL)
				{
				cumul_cout +=  (pa->et - pa->st) * Ressources[r][8] + Ressources[r][7] ;
				pa = pa->next;
				}
			}
		}


return(cumul_cout);
}

