// --- Structure.h ---

// Structures utilisees pour le challenge ROADEF


// Pour les orders : tableau de liste classees par ressources
// ==========================================================

// Definition de la structure Order 
typedef struct order *ptorder;
typedef struct order
	{
	int order_id;	// Identity
	int st;			// Starting time
	int et;			// Ending time
	int rq;			// required quantity
	int rtype_id;	// Ressource type
	int alloc;		// Nb of allocated ressources
	ptorder next;	// Next order in the list
	} torder;



// Pour les substitutions : tableau de liste par ressources
// ========================================================

// Definition de la structure cell
typedef struct cellu *ptcellu;
typedef struct cellu
	{
	int nb_res;		// Number of the substituable ressource
	ptcellu next;	// Next substituable ressource in the list
	} tcellu;



// Pour les affectations : tableau de cellules
// ===========================================

// Definition de la cellule 
typedef struct affect *ptaffect;
typedef struct affect
	{
	ptorder order;	// Identity
	int st;			// Starting time
	int et;			// Ending time
	ptaffect next;	// Next affect in the list
	} taffect;
	


// Pour les intervalles de maintenance : tableau de cellules
// =========================================================

// Definition de la cellule 
typedef struct int_maint *ptint_maint;
typedef struct int_maint
	{
	int rtype_id;		// Type
	int item_id;		// Identity
	int st;				// Starting time of the Time Window
	int et;				// Ending time of the Time Window
	ptint_maint next;	// Next interval  in the list
	} tint_maint;
	


// Pour la maintenance finale : tableau de cellules
// ================================================

// Definition de la cellule 
typedef struct maint *ptmaint;
typedef struct maint
	{
	//int rtype_id;	// Type
	//int item_id;	// Identity
	int t;			// Starting time
	ptmaint next;	// Next maint in the list
	} tmaint;
	


// Pour les locations : tableau de cellules
// ========================================

// Definition de la cellule 
typedef struct rent *ptrent;
typedef struct rent
	{
	ptorder order;	// Identity
	int rtype_id;	// Type
	int order_id;	// Identity
	int st;			// Starting time
	int et;			// Ending time
	int r_number;	// Quantity
	ptrent next;	// Next rent in the list
	} trent;
	





